/************************************************************************************/
//	ȨУCopyright (c) 2005 - 2010 ICRoute INC.
/************************************************************************************/	  
#ifndef LD_CHIP_H
#define LD_CHIP_H

	#define uint8  unsigned char
	#define uint16 unsigned int
	#define uint32 unsigned long   	 	
								
	#define CLK_IN   		    22.1184	//  ûԸṩLD3320ģʵʾƵ޸
	#define LD_PLL_11			(uint8)((CLK_IN/2.0)-1)

	#define LD_PLL_ASR_19 		(uint8)(CLK_IN*32.0/(LD_PLL_11+1) - 0.51)
	#define LD_PLL_ASR_1B 		0x48
	#define LD_PLL_ASR_1D 		0x1f

	
	#define MASK_INT_SYNC				0x10
	#define MASK_INT_FIFO				0x04
	#define MASK_AFIFO_INT				0x01
	#define MASK_FIFO_STATUS_AFULL		0x08

	//	״̬¼ASRʶеĸ״̬
	#define LD_ASR_NONE			0x00	//	ʾûASRʶ
	#define LD_ASR_RUNING		0x01	//	ʾLD3320ASRʶ
	#define LD_ASR_FOUNDOK		0x10	//	ʾһʶ̽һʶ
	#define LD_ASR_FOUNDZERO 	0x11	//	ʾһʶ̽ûʶ
	#define LD_ASR_ERROR	 	0x31	//	ʾһʶLD3320оƬڲֲȷ״̬
	
	/****************************************************************
	 LD_WriteReg
	ܣдLD3320оƬļĴ
	  address, 8λ޷ַ
			dataout8λ޷Ҫд
	ֵ
	****************************************************************/ 
	void LD_WriteReg( unsigned char address, unsigned char dataout );
	
	/****************************************************************
	 LD_ReadReg
	ܣLD3320оƬļĴ
	  address, 8λ޷ַ
	ֵ8λ޷ȡĽ
	****************************************************************/ 
	unsigned char LD_ReadReg( unsigned char address );	
	void LD_reset();
	
	void LD_Init_Common();	  
	void LD_Init_ASR();	  

	void LD_AdjustMIX2SPVolume(uint8 value);  	
	uint8 LD_ProcessAsr(uint32 RecogAddr);
	void LD_AsrStart();
	uint8 LD_AsrRun();
	uint8 LD_AsrAddFixed();
	uint8 LD_GetResult();

	void delay(unsigned long uldata); 

    void ProcessInt0();
	uint8 RunASR();
	extern void _nop_ (void);

	void MCU_init();   
	uint8 RunASR();
	void  ProcessInt0();
	void  test_led(void);
#endif
